// doubly-linked lists

struct list_node_s {
    struct list_node_s *next, *prev;
    void *data;
};

typedef struct list_node_s *list_node_ptr;
typedef struct list_node_s list_node_t[1];

struct list_s {
    list_node_t sentinel;
    unsigned int count;
};
typedef struct list_s *list_ptr;
typedef struct list_s list_t[1];

struct list_iterator_s {
    list_node_ptr node;
    list_ptr list;
};
typedef struct list_iterator_s *list_iterator_ptr;
typedef struct list_iterator_s list_iterator_t[1];

void list_init(list_ptr l);
void list_insert(list_ptr l, void *data);
void list_append(list_ptr l, void *data);
void list_forall(list_ptr l, void (*f)(void *));
void list_iterator_init(list_iterator_ptr it, list_ptr l);
void list_iterator_insert(list_iterator_ptr it, void *data);
void list_iterator_append(list_iterator_ptr it, void *data);
void list_iterator_next(list_iterator_ptr it);
void list_iterator_prev(list_iterator_ptr it);
void list_iterator_first(list_iterator_ptr it);
void list_iterator_last(list_iterator_ptr it);
int list_iterator_is_end(list_iterator_ptr it);
