struct symtab_cl_s;

struct symtab_s {
    struct symtab_cl_s *cl;
    void *data;
};

typedef struct symtab_s *symtab_ptr;
typedef struct symtab_s symtab_t[1];

struct symtab_cl_s {
    void *(*at)(symtab_ptr, char *);
    void (*put)(symtab_ptr, void *, char *);
    void (*print)(symtab_ptr);
    void (*clear)(symtab_ptr);
};

typedef struct symtab_cl_s *symtab_cl_ptr;
typedef struct symtab_cl_s symtab_cl_t[1];

static inline void symtab_put(symtab_ptr st, void *data, char *key)
{
    st->cl->put(st, data, key);
}

static inline void *symtab_at(symtab_ptr st, char *key)
{
    return st->cl->at(st, key);
}

static inline void symtab_print(symtab_ptr st)
{
    st->cl->print(st);
}

void symtab_init_cbt(symtab_ptr st);
void symtab_init_hashtab(symtab_ptr st);
